Imports System.IO
Imports System.Data.SqlClient
Imports System.Data

Partial Class Select_MSSQL
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' When the page loads we get data from session variables to us in our Select statements
        If Page.IsPostBack = False Then
            HiddenCompanyID.Value = Convert.ToString(Session("CompanyID"))
            HiddenYearID.Value = Convert.ToString(Session("YearID"))
            HiddenCompanyName.Value = Convert.ToString(Session("CompanyName"))
        End If
    End Sub
    Protected Sub BtnCheckUserName_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BtnCheckUserName.Click

        ' This code is to select just one value "UserName" to "lookupUserName" from a table by using "ExecuteScalar()" as the command
        Dim lookupUserName As String = ""

        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()

            ' Check to see if username already exists
            Dim SelectUser As String = "SELECT UserName FROM Users WHERE UserName = @UserName"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(SelectUser, cn)
                cmd.Parameters.Add("@UserName", SqlDbType.VarChar, 80).Value = txtUserName.Text

                ' Execute command and fetch UserName field into lookupUserName string.
                cn.Open()
                lookupUserName = Convert.ToString(cmd.ExecuteScalar())

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

        ' Compare the supplied username to the selected username from Users table and print to a label
        If lookupUserName = txtUserName.Text Then
            UserNameLabel.Text = "Username already exists in the database"
        Else
            UserNameLabel.Text = "Username does not exist in the database"
        End If
    End Sub
    Protected Sub btnGetData_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnGetData.Click

        ' This code is to select rows from the table Assets with a SqlDataReader where the companyid matches
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT Place, AssetOwnID, AssetName, VerNumber, Supplier FROM Assets WHERE CompanyID = @CompanyID AND SoldScraped = '0' ORDER BY Place"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@CompanyID", SqlDbType.BigInt).Value = HiddenCompanyID.Value

                cn.Open()
                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using reader As SqlDataReader = cmd.ExecuteReader()
                    SelectToRepeaterDataReader.DataSource = reader
                    SelectToRepeaterDataReader.DataBind()
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Protected Sub btnGetUserData_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnGetUserData.Click

        ' This code shows how to select one row from the Users table where the username is equal to the entered username by
        ' using a SqlDataReader.
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT * FROM Users WHERE Username = @Username"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@Username", SqlDbType.VarChar, 80).Value = txtUserName2.Text

                cn.Open()
                ' We use SqlDataReader and just want to select one single row, the Using block
                ' is used to call dispose (close) automatically even if there are an exception.
                Using reader As SqlDataReader = cmd.ExecuteReader(CommandBehavior.SingleRow)
                    While reader.Read()
                        txtUserID.Text = reader("UserID").ToString()
                        txtUserName.Text = reader("Username").ToString()
                        txtCompanyName.Text = reader("Company").ToString()
                        txtOrganisationNumber.Text = reader("OrgNumber").ToString()
                        txtContact.Text = reader("Contact").ToString()
                        txtAttention.Text = reader("Attention").ToString()
                        txtAdress.Text = reader("Adress").ToString()
                        txtPostalCode.Text = reader("PostalCode").ToString()
                        txtCity.Text = reader("City").ToString()
                        txtCountry.Text = reader("Country").ToString()
                    End While
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Protected Sub BtnSelectAssets_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BtnSelectAssets.Click

        ' This is code to select data to a dataset with two tables so that we kan make groups and calculate values
        ' Asset accounts in parentrepeater and assets inside childrepeater
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT AssetTypeID, AssetAccount, TypeName FROM AssetType WHERE CompanyID = @CompanyID GROUP BY AssetTypeID, AssetAccount, TypeName ORDER BY AssetAccount ASC"
            Dim sql2 As String = "SELECT A.AssetOwnID, A.AssetType, A.AssetName, A.PurchaseDate, A.PurchasePrice, SUM(COALESCE(SumIB, 0)) As YearIB, SUM(COALESCE(SumYearDep,0)) As YearDep, SUM(COALESCE(SumIB, 0) + COALESCE(SumYearDep,0)) As SumAckDeprication, SUM(A.PurchasePrice - (COALESCE(SumIB, 0) + COALESCE(SumYearDep,0))) As AccountedValue FROM Assets AS A LEFT OUTER JOIN (SELECT AssetID, SUM(IBValue) As SumIB FROM IBDeprication WHERE YearID = @YearID GROUP BY AssetID) As IB ON A.AssetID = IB.AssetID LEFT OUTER JOIN (SELECT AssetID, SUM(DepricationValue) As SumYearDep FROM Deprication WHERE YearID = @YearID GROUP BY AssetID) AS D ON A.AssetID = D.AssetID WHERE A.CompanyID = @CompanyID AND A.SoldScraped = '0' OR A.DateSold > @Slutdatum GROUP BY A.AssetOwnID, A.AssetType, A.AssetName, A.PurchaseDate, A.PurchasePrice ORDER BY A.PurchaseDate ASC"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                ad As New SqlDataAdapter(), _
                cmd As New SqlCommand(sql, cn), _
                ad2 As New SqlDataAdapter(), _
                cmd2 As New SqlCommand(sql2, cn)
                cmd.Parameters.Add("@CompanyID", SqlDbType.BigInt).Value = HiddenCompanyID.Value
                cmd2.Parameters.Add("@YearID", SqlDbType.BigInt).Value = HiddenYearID.Value
                cmd2.Parameters.Add("@CompanyID", SqlDbType.BigInt).Value = HiddenCompanyID.Value
                cmd2.Parameters.Add("@Slutdatum", SqlDbType.Date).Value = txtEndDate.Text

                cn.Open()

                ' Fill dataset with assettypes as first table
                ad.SelectCommand = cmd

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using ds As New DataSet()

                    ad.Fill(ds, "AssetTypes")

                    ' Fill dataset with assets as second table
                    ad2.SelectCommand = cmd2
                    ad2.Fill(ds, "Assets")

                    ' Create the relation bewtween the AssetTypes and Assets tables.
                    ds.Relations.Add("assetsrelation", ds.Tables("AssetTypes").Columns("AssetTypeID"), ds.Tables("Assets").Columns("AssetType"))

                    ' Calculate subtotals
                    Dim PPTotal As DataColumn = New DataColumn("PPTotalt", System.Type.GetType("System.Decimal"), "Sum(Child(assetsrelation).PurchasePrice)")
                    PPTotal.AutoIncrement = False
                    PPTotal.ReadOnly = True
                    Dim IBTotal As DataColumn = New DataColumn("IBtotalt", System.Type.GetType("System.Decimal"), "Sum(Child(assetsrelation).YearIB)")
                    IBTotal.AutoIncrement = False
                    IBTotal.ReadOnly = True
                    Dim YearTotal As DataColumn = New DataColumn("YearDepTotalt", System.Type.GetType("System.Decimal"), "Sum(Child(assetsrelation).YearDep)")
                    YearTotal.AutoIncrement = False
                    YearTotal.ReadOnly = True
                    Dim AckDepTotal As DataColumn = New DataColumn("AckDepTotalt", System.Type.GetType("System.Decimal"), "Sum(Child(assetsrelation).SumAckDeprication)")
                    AckDepTotal.AutoIncrement = False
                    AckDepTotal.ReadOnly = True
                    Dim AccValueTotal As DataColumn = New DataColumn("AccValueTotalt", System.Type.GetType("System.Decimal"), "Sum(Child(assetsrelation).AccountedValue)")
                    AccValueTotal.AutoIncrement = False
                    AccValueTotal.ReadOnly = True

                    ' Add columns to table AssetTypes
                    ds.Tables("AssetTypes").Columns.Add(PPTotal)
                    ds.Tables("AssetTypes").Columns.Add(IBTotal)
                    ds.Tables("AssetTypes").Columns.Add(YearTotal)
                    ds.Tables("AssetTypes").Columns.Add(AckDepTotal)
                    ds.Tables("AssetTypes").Columns.Add(AccValueTotal)

                    ' Bind the AssetTypes table to the parentrepeater control, and call DataBind. Data for the 
                    ' childrepeater gets in Select-MySQL.aspx from the dataset.
                    parentRepeater.DataSource = ds.Tables("AssetTypes")
                    Page.DataBind()
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
End Class
